diff --git a/CMakeLists.txt b/CMakeLists.txt
index cd7189aa..7166ec73 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -19,9 +19,13 @@ else()
     find_package(DummyPkgConfig REQUIRED)
 endif()
 
-find_package(Qt5Widgets 5.6 REQUIRED)
-if(Qt5Widgets_VERSION VERSION_LESS 5.6.3)
-    message(AUTHOR_WARNING "Qt5 >= 5.6.3, >= 5.9.1 is recommended")
+option(USE_QT4 "Build with Qt4" ON)
+
+if(USE_QT4)
+    find_package(Qt4 REQUIRED QtCore QtGui)
+    include("${QT_USE_FILE}")
+else()
+    find_package(Qt5Widgets 5.10 REQUIRED)
 endif()
 
 set(CMAKE_LINK_DEPENDS_NO_SHARED ON)
@@ -49,6 +53,10 @@ endif()
 
 add_definitions(-D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS -DQT_USE_FAST_OPERATOR_PLUS)
 
+if(APPLE AND USE_QT4)
+    add_definitions(-DQ_OS_MACOS)
+endif()
+
 if(WIN32)
     option(USE_CMD "Show CMD when running QMPlay2" OFF)
     mark_as_advanced(USE_CMD)
@@ -283,7 +291,7 @@ endif()
 
 if(APPLE)
     find_library(APPKIT_LIBRARY AppKit)
-    find_library(IOKIT_LIBRARY IoKit)
+    find_library(IOKIT_LIBRARY IOKit)
     set(SOLID_ACTIONS_DEFAULT "None")
     set(DEFAULT_INSTALL_RPATH ON)
 endif()
@@ -306,7 +314,11 @@ if(USE_MEDIABROWSER)
 endif()
 
 if(NOT ANDROID)
+  if(USE_QT4)
+    find_package(Qt4 QUIET OPTIONAL_COMPONENTS QtSvg)
+  else()
     find_package(Qt5Svg QUIET)
+  endif()
 else()
     find_package(Qt5Svg REQUIRED)
     find_package(Qt5AndroidExtras REQUIRED)
@@ -337,7 +349,7 @@ if(NOT APPLE AND NOT WIN32)
 endif()
 
 # Show warning if QtSvg doesn't exist
-if(NOT Qt5Svg_FOUND)
+if(NOT Qt5Svg_FOUND AND NOT Qt4_FOUND)
     message(WARNING "Missing QtSvg module - SVG icons will not be visible!")
 endif()
 
diff --git a/lang/CMakeLists.txt b/lang/CMakeLists.txt
index db28debd..bb5043e7 100644
--- a/lang/CMakeLists.txt
+++ b/lang/CMakeLists.txt
@@ -12,8 +12,12 @@ else()
     endforeach()
 endif()
 
-find_package(Qt5LinguistTools REQUIRED)
-qt5_add_translation(QM_FILES ${QMPLAY2_TSS})
+if(USE_QT4)
+    qt4_add_translation(QM_FILES ${QMPLAY2_TSS})
+else()
+    find_package(Qt5LinguistTools REQUIRED)
+    qt5_add_translation(QM_FILES ${QMPLAY2_TSS})
+endif()
 
 add_custom_target(translations ALL DEPENDS ${QM_FILES})
 
diff --git a/src/gui/AboutWidget.cpp b/src/gui/AboutWidget.cpp
index dfc52ccd..0f867e67 100644
--- a/src/gui/AboutWidget.cpp
+++ b/src/gui/AboutWidget.cpp
@@ -52,7 +52,8 @@ AboutWidget::AboutWidget()
 
     QTabWidget *tabW = new QTabWidget;
 
-    const QFont font(QFontDatabase::systemFont(QFontDatabase::FixedFont));
+    QFont font("Monospace");
+    font.setStyleHint(QFont::TypeWriter);
 
     logE = new QPlainTextEdit;
     logE->setFont(font);
diff --git a/src/gui/AboutWidget.hpp b/src/gui/AboutWidget.hpp
index 98994f7a..59af0de5 100644
--- a/src/gui/AboutWidget.hpp
+++ b/src/gui/AboutWidget.hpp
@@ -24,14 +24,14 @@
 class QPlainTextEdit;
 class QPushButton;
 
-class AboutWidget final : public QWidget
+class AboutWidget : public QWidget
 {
     Q_OBJECT
 public:
     AboutWidget();
 private:
-    void showEvent(QShowEvent *) override;
-    void closeEvent(QCloseEvent *) override;
+    void showEvent(QShowEvent *) override final;
+    void closeEvent(QCloseEvent *) override final;
 
     QPlainTextEdit *logE, *clE, *auE;
     QPushButton *clrLogB;
diff --git a/src/gui/AddressDialog.hpp b/src/gui/AddressDialog.hpp
index 4a6f779a..3835b97d 100644
--- a/src/gui/AddressDialog.hpp
+++ b/src/gui/AddressDialog.hpp
@@ -24,12 +24,12 @@
 #include <QCheckBox>
 #include <QDialog>
 
-class AddressDialog final : public QDialog
+class AddressDialog : public QDialog
 {
     Q_DECLARE_TR_FUNCTIONS(AddressDialog)
 public:
     AddressDialog(QWidget *);
-    ~AddressDialog();
+    ~AddressDialog() final;
 
     inline bool addAndPlay() const
     {
diff --git a/src/gui/AudioThr.hpp b/src/gui/AudioThr.hpp
index f2382376..c0842611 100644
--- a/src/gui/AudioThr.hpp
+++ b/src/gui/AudioThr.hpp
@@ -28,14 +28,14 @@ class QMPlay2Extensions;
 class PlayClass;
 class AudioFilter;
 
-class AudioThr final : public AVThread
+class AudioThr : public AVThread
 {
     Q_OBJECT
 public:
     AudioThr(PlayClass &, const QStringList &pluginsName = {});
-    ~AudioThr();
+    ~AudioThr() final;
 
-    void stop(bool terminate = false) override;
+    void stop(bool terminate = false) override final;
     void clearVisualizations();
 
     bool setParams(uchar realChn, uint realSRate, uchar chn, uint sRate, bool resamplerFirst);
@@ -47,7 +47,7 @@ public:
         allowAudioDrain = true;
     }
 private:
-    void run() override;
+    void run() override final;
 
     bool resampler_create();
 
@@ -55,7 +55,7 @@ private:
     inline uint currentSampleRate() const;
 
 #ifdef Q_OS_WIN
-    void timerEvent(QTimerEvent *) override;
+    void timerEvent(QTimerEvent *) override final;
 #endif
 
     SndResampler sndResampler;
diff --git a/src/gui/CMakeLists.txt b/src/gui/CMakeLists.txt
index 7f8c22b5..8bd630af 100644
--- a/src/gui/CMakeLists.txt
+++ b/src/gui/CMakeLists.txt
@@ -34,10 +34,15 @@ set(GUI_HDR
     KeyBindingsDialog.hpp
     Updater.hpp
     RepeatMode.hpp
-    PanGestureEventFilter.hpp
-    EventFilterWorkarounds.hpp
 )
 
+if(NOT USE_QT4)
+    list(APPEND GUI_HDR
+        PanGestureEventFilter.hpp
+        EventFilterWorkarounds.hpp
+    )
+endif()
+
 set(GUI_SRC
     Main.cpp
     MenuBar.cpp
@@ -65,7 +70,6 @@ set(GUI_SRC
     ShortcutHandler.cpp
     KeyBindingsDialog.cpp
     Updater.cpp
-    EventFilterWorkarounds.cpp
 )
 
 set(GUI_FORMS # *.ui files
@@ -79,24 +83,35 @@ set(GUI_RESOURCES
     resources.qrc
 )
 
-if(NOT WIN32)
+if(NOT USE_QT4)
     list(APPEND GUI_SRC
-        PanGestureEventFilter.cpp
+        EventFilterWorkarounds.cpp
     )
+    if(NOT WIN32)
+        list(APPEND GUI_SRC
+            PanGestureEventFilter.cpp
+        )
+    endif()
 endif()
 
 if(APPLE)
     list(APPEND GUI_HDR
         macOS/QMPlay2MacExtensions.hpp
     )
-    list(APPEND GUI_SRC
-        macOS/QMPlay2MacExtensions.mm
-    )
+    if(NOT USE_QT4)
+        list(APPEND GUI_SRC
+           macOS/QMPlay2MacExtensions.mm
+        )
+    endif()
 
     include_directories("macOS")
 endif()
 
-qt5_wrap_ui(GUI_FORM_HDR ${GUI_FORMS})
+if(USE_QT4)
+    qt4_wrap_ui(GUI_FORM_HDR ${GUI_FORMS})
+else()
+    qt5_wrap_ui(GUI_FORM_HDR ${GUI_FORMS})
+endif()
 set_property(SOURCE ${GUI_FORM_HDR} PROPERTY SKIP_AUTOMOC ON)
 
 include_directories(../qmplay2/headers)
@@ -121,7 +136,7 @@ if(USE_TAGLIB)
     list(APPEND GUI_SRC TagEditor.cpp)
 endif()
 
-if(NOT APPLE)
+if(USE_QT4 OR NOT APPLE)
     add_definitions(-DQMPLAY2_ALLOW_ONLY_ONE_INSTANCE)
 endif()
 
@@ -216,11 +231,13 @@ if(WIN32)
 elseif(APPLE)
     install(TARGETS ${PROJECT_NAME} BUNDLE DESTINATION ${CMAKE_INSTALL_PREFIX})
 
-    set(QT_LIBS_DIR "${Qt5Widgets_DIR}/../..")
-    set(QT_PLUGINS_DIR "${QT_LIBS_DIR}/../plugins")
+    set(QT_LIBS_DIR "@qt_libs_dir@")
+    set(QT_PLUGINS_DIR "@qt_plugins_dir@")
+if(NOT USE_QT4)
     install(FILES
         "${QT_PLUGINS_DIR}/platforms/libqcocoa.dylib"
         DESTINATION "${MAC_BUNDLE_PATH}/Contents/plugins/platforms")
+endif()
     install(FILES
         "${QT_PLUGINS_DIR}/iconengines/libqsvgicon.dylib"
         DESTINATION "${MAC_BUNDLE_PATH}/Contents/plugins/iconengines")
@@ -238,23 +255,7 @@ elseif(APPLE)
         DESTINATION "${MAC_BUNDLE_PATH}/Contents"
         FILES_MATCHING
         PATTERN "qtbase_*.qm")
-    if(EXISTS "/usr/local/bin/ffmpeg")
-        install(PROGRAMS
-            "/usr/local/bin/ffmpeg"
-            DESTINATION "${MAC_BUNDLE_PATH}/Contents/MacOS")
-    else()
-        message(WARNING "FFmpeg executable not copied!")
-    endif()
-    install(CODE "
-        include(BundleUtilities)
-        set(BU_CHMOD_BUNDLE_ITEMS ON)
-        list(APPEND DIRS /usr/local/lib ${QT_LIBS_DIR})
-        file(GLOB_RECURSE QMPLAY2_MODULES_AND_QT_PLUGINS
-            \"${MAC_BUNDLE_PATH}/Contents/MacOS/modules/*\"
-            \"${MAC_BUNDLE_PATH}/Contents/plugins/*.dylib\")
-        file(WRITE \"${MAC_BUNDLE_PATH}/Contents/Resources/qt.conf\")
-        fixup_bundle(${MAC_BUNDLE_PATH} \"\${QMPLAY2_MODULES_AND_QT_PLUGINS}\" \"\${DIRS}\")
-    ")
+    file(WRITE \"@destroot@${MAC_BUNDLE_PATH}/Contents/Resources/qt.conf\")
 else()
     # executable
     install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
diff --git a/src/gui/DeintSettingsW.hpp b/src/gui/DeintSettingsW.hpp
index ea74fac2..92787425 100644
--- a/src/gui/DeintSettingsW.hpp
+++ b/src/gui/DeintSettingsW.hpp
@@ -24,14 +24,14 @@ class QCheckBox;
 class QComboBox;
 class Module;
 
-class DeintSettingsW final : public QGroupBox
+class DeintSettingsW : public QGroupBox
 {
     Q_OBJECT
 public:
     static void init();
 
     DeintSettingsW();
-    ~DeintSettingsW();
+    ~DeintSettingsW() final;
 
     void writeSettings();
 private slots:
diff --git a/src/gui/DemuxerThr.cpp b/src/gui/DemuxerThr.cpp
index 2fdedd42..60dbf30b 100644
--- a/src/gui/DemuxerThr.cpp
+++ b/src/gui/DemuxerThr.cpp
@@ -451,6 +451,12 @@ void DemuxerThr::run()
     if (stillImage && playC.paused)
         playC.paused = false;
 
+    const bool isHls = (demuxer->name() == "hls");
+    QTime waitForDataTimer;
+    bool waitForDataTimerValid = false;
+    bool firstWaitForData = true;
+    bool canWaitForData = true;
+
     while (!demuxer.isAborted())
     {
         {
@@ -534,9 +540,33 @@ void DemuxerThr::run()
             )
         )
         {
+            if (isHls && !firstWaitForData && canWaitForData && !playC.endOfStream)
+            {
+                // Wait a bit longer for HLS streams to prevent stuttering on every HLS chunk. Do a short
+                // sleep and continue, because reading from demuxer might block for HLS chunk length.
+                if (!waitForDataTimerValid)
+                {
+                    waitForDataTimer.start();
+                    waitForDataTimerValid = true;
+                }
+                if (waitForDataTimer.elapsed() / 1000.0 <= playIfBuffered)
+                {
+                    msleep(50);
+                    continue;
+                }
+                waitForDataTimerValid = false;
+                canWaitForData = false;
+            }
+
             playC.waitForData = false;
             if (!paused)
                 playC.emptyBufferCond.wakeAll();
+
+            firstWaitForData = false;
+        }
+        else
+        {
+            canWaitForData = true;
         }
 
         if (playC.endOfStream || bufferedAllPackets(vS, aS, forwardPackets))
diff --git a/src/gui/DemuxerThr.hpp b/src/gui/DemuxerThr.hpp
index 35db9e36..9fdfd88d 100644
--- a/src/gui/DemuxerThr.hpp
+++ b/src/gui/DemuxerThr.hpp
@@ -32,14 +32,14 @@ class AVThread;
 class Demuxer;
 class BasicIO;
 
-class DemuxerThr final : public QThread
+class DemuxerThr : public QThread
 {
     friend class DemuxerTimer;
     friend class PlayClass;
     Q_OBJECT
 private:
     DemuxerThr(PlayClass &);
-    ~DemuxerThr();
+    ~DemuxerThr() final;
 
     QByteArray getCoverFromStream() const;
 
@@ -65,7 +65,7 @@ private:
 
     void checkReadyWrite(AVThread *avThr);
 
-    void run() override;
+    void run() override final;
 
     inline void ensureTrueUpdateBuffered();
     inline bool canUpdateBuffered() const;
diff --git a/src/gui/EntryProperties.cpp b/src/gui/EntryProperties.cpp
index d537bb9e..21c8da7d 100644
--- a/src/gui/EntryProperties.cpp
+++ b/src/gui/EntryProperties.cpp
@@ -107,12 +107,6 @@ EntryProperties::EntryProperties(QWidget *p, QTreeWidgetItem *_tWI, bool &sync,
         addrB = new AddressBox(Qt::Horizontal, url);
         layout.addWidget(addrB, row, 0, 1, 2);
 
-        openUrlB = new QToolButton;
-        openUrlB->setToolTip(tr("Open URL or directory containing chosen file"));
-        openUrlB->setIcon(QMPlay2Core.getIconFromTheme("folder-open"));
-        connect(openUrlB, &QToolButton::clicked, this, &EntryProperties::openUrl);
-        layout.addWidget(openUrlB, row, 2, 1, 1);
-
         fileSizeL = new QLabel;
 
 #ifdef QMPlay2_TagEditor
diff --git a/src/gui/EntryProperties.hpp b/src/gui/EntryProperties.hpp
index d89c2ccb..ba203300 100644
--- a/src/gui/EntryProperties.hpp
+++ b/src/gui/EntryProperties.hpp
@@ -30,7 +30,7 @@ class QCheckBox;
 #endif
 class QLabel;
 
-class EntryProperties final : public QDialog
+class EntryProperties : public QDialog
 {
     Q_OBJECT
 public:
@@ -54,6 +54,6 @@ private slots:
 #endif
     void browse();
     void openUrl();
-    void accept() override;
-    void reject() override;
+    void accept() override final;
+    void reject() override final;
 };
diff --git a/src/gui/EventFilterWorkarounds.hpp b/src/gui/EventFilterWorkarounds.hpp
index e8c28cff..ce32dda1 100644
--- a/src/gui/EventFilterWorkarounds.hpp
+++ b/src/gui/EventFilterWorkarounds.hpp
@@ -20,7 +20,7 @@
 
 #include <QObject>
 
-class EventFilterWorkarounds final : public QObject
+class EventFilterWorkarounds : public QObject
 {
     Q_OBJECT
 
@@ -29,5 +29,5 @@ public:
     ~EventFilterWorkarounds();
 
 private:
-    bool eventFilter(QObject *watched, QEvent *event) override;
+    bool eventFilter(QObject *watched, QEvent *event) override final;
 };
diff --git a/src/gui/InfoDock.hpp b/src/gui/InfoDock.hpp
index cd3354a6..c46c4c7b 100644
--- a/src/gui/InfoDock.hpp
+++ b/src/gui/InfoDock.hpp
@@ -22,11 +22,11 @@
 
 #include <DockWidget.hpp>
 
-class TextEdit final : public QTextEdit
+class TextEdit : public QTextEdit
 {
 private:
-    void mouseMoveEvent(QMouseEvent *) override;
-    void mousePressEvent(QMouseEvent *) override;
+    void mouseMoveEvent(QMouseEvent *) override final;
+    void mousePressEvent(QMouseEvent *) override final;
 };
 
 /**/
diff --git a/src/gui/KeyBindingsDialog.cpp b/src/gui/KeyBindingsDialog.cpp
index 3dca5428..4c71bdd0 100644
--- a/src/gui/KeyBindingsDialog.cpp
+++ b/src/gui/KeyBindingsDialog.cpp
@@ -35,8 +35,8 @@ KeyBindingsDialog::KeyBindingsDialog(QWidget *p) :
     shortcuts->setModel(QMPlay2GUI.shortcutHandler);
     shortcuts->setFrameShape(QFrame::NoFrame);
     shortcuts->setAlternatingRowColors(true);
-    shortcuts->horizontalHeader()->setSectionResizeMode(0, QHeaderView::ResizeToContents);
-    shortcuts->horizontalHeader()->setSectionResizeMode(1, QHeaderView::Stretch);
+    shortcuts->horizontalHeader()->setResizeMode(0, QHeaderView::ResizeToContents);
+    shortcuts->horizontalHeader()->setResizeMode(1, QHeaderView::Stretch);
     shortcuts->setSelectionMode(QAbstractItemView::SingleSelection);
     shortcuts->verticalHeader()->setVisible(false);
 
